"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// lib/index.ts
var lib_exports = {};
__export(lib_exports, {
  default: () => lib_default
});
module.exports = __toCommonJS(lib_exports);

// lib/rules/my-rule.ts
var import_eslint_utils = require("@typescript-eslint/utils/eslint-utils");
var import_utils = require("@typescript-eslint/utils");
var createRule = (0, import_eslint_utils.RuleCreator)((name) => `https://my-website.io/eslint/${name}`);
var myRule = createRule({
  name: "my-rule",
  meta: {
    docs: {
      description: "An example ESLint rule"
    },
    hasSuggestions: true,
    messages: {
      // Message IDs don't need to be prefixed, I just find it easier to keep track of them this way
      "issue:var": "Prefer using `let` or `const`",
      "fix:let": "Replace this `var` declaration with `let`",
      "fix:const": "Replace this `var` declaration with `const`"
    },
    schema: [],
    type: "suggestion"
  },
  defaultOptions: [],
  create: (context) => {
    return {
      VariableDeclaration: (node) => {
        if (node.kind === "var") {
          const range = [
            0,
            3
            /* 'var'.length */
          ];
          context.report({
            node,
            messageId: "issue:var",
            // Prints the message with this ID when a problem is found
            suggest: [
              {
                messageId: "fix:let",
                fix: (fixer) => fixer.replaceTextRange(range, "let")
              },
              {
                messageId: "fix:const",
                fix: (fixer) => fixer.replaceTextRange(range, "const")
              }
            ]
          });
        }
      }
    };
  }
});

// lib/rules/index.ts
var rules = {
  "my-rule": myRule
};

// lib/index.ts
var plugin = {
  meta: {
    name: "eslint-plugin-demo-typescript",
    // or `@my-scope/eslint-plugin`
    version: "0.0.1"
  },
  rules
};
var lib_default = plugin;
